//*******************************************************************
// Aisa59w.pas
//
// aISA-M59
//
// Copyrigt ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//*******************************************************************
unit Aisa59w;

interface

uses
	Windows;

const
	// DLL Name
	AISA59_DLL_NAME												='Aisa59.DLL';

	// Error code
	AISA59_SUCCESS												=0;		// ُȂiIj
	AISA59_ERR_SYSTEM											=1;		// VXeG[
	AISA59_ERR_NO_DEVICE									=2;		// gp\ȃfoCX܂
	AISA59_ERR_IN_USE											=3;		// w̃foCX͎gpł
	AISA59_ERR_INVALID_SLOT								=4;		// Ș_Xbgł
	AISA59_ERR_RESOURCE										=5;		// \[XG[
	AISA59_ERR_INVALID_PORT								=6;		// sȃ|[gv
	AISA59_ERR_INVALID_ARGUMENT						=7;		// sȈv܂
	AISA59_ERR_INVALID_AXIS								=50; 	// Ȑ䎲v
	AISA59_ERR_INVALID_CMD								=51; 	// ȃR}hv
	AISA59_ERR_INVALID_SIG								=52; 	// ȃVOił
	AISA59_ERR_INVALID_MODE								=53; 	// ȃ[hł

	// Axis
	AISA59_AXIS_1													=0;
	AISA59_AXIS_2													=1;
	AISA59_AXIS_3													=2;
	AISA59_AXIS_4													=3;

	// Write command
	AISA59_RANGE_WRITE										=$00;
	AISA59_START_STOP_SPEED_DATA_WRITE		=$02;
	AISA59_OBJECT_SPEED_DATA_WRITE				=$04;
	AISA59_RATE1_DATA_WRITE								=$06;
	AISA59_RATE2_DATA_WRITE								=$08;
	AISA59_RATE3_DATA_WRITE								=$0A;
	AISA59_RATE_CHANGE_POINT_1_2_WRITE		=$0C;
	AISA59_RATE_CHANGE_POINT_2_3_WRITE		=$0E;
	AISA59_SLOW_DOWN_REAR_PULSE_WRITE			=$10;
	AISA59_PRESET_PULSE_DATA_OVERRIDE			=$14;
	AISA59_INTERNAL_COUNTER_WRITE					=$28;
	AISA59_INTERNAL_COMPARATE_DATA_WRITE	=$2A;
	AISA59_EXTERNAL_COUNTER_WRITE					=$2C;
	AISA59_EXTERNAL_COMPARATE_DATA_WRITE	=$2D;

	// Read command
	AISA59_RANGE_READ											=$01;
	AISA59_START_STOP_SPEED_DATA_READ			=$03;
	AISA59_OBJECT_SPEED_DATA_READ					=$05;
	AISA59_RATE1_DATA_READ								=$07;
	AISA59_RATE2_DATA_READ								=$09;
	AISA59_RATE3_DATA_READ								=$0B;
	AISA59_RATE_CHANGE_POINT_1_2_READ			=$0D;
	AISA59_RATE_CHANGE_POINT_2_3_READ			=$0F;
	AISA59_SLOW_DOWN_REAR_PULSE_READ			=$11;
	AISA59_NOW_SPEED_DATA_READ						=$12;
	AISA59_DRIVE_PULSE_COUNTER_READ				=$13;
	AISA59_PRESET_PULSE_DATA_READ					=$15;
	AISA59_DEVIATION_DATA_READ						=$16;
	AISA59_INTERNAL_COUNTER_READ					=$29;
	AISA59_INTERNAL_COMPARATE_DATA_READ		=$2B;
	AISA59_EXTERNAL_COUNTER_READ					=$2D;
	AISA59_EXTERNAL_COMPARATE_DATA_READ		=$2F;

	// Drive command
	AISA59_PLUS_PRESET_PULSE_DRIVE				=$20;
	AISA59_MINUS_PRESET_PULSE_DRIVE				=$21;
	AISA59_PLUS_CONTINUOUS_DRIVE					=$22;
	AISA59_MINUS_CONTINUOUS_DRIVE					=$23;
	AISA59_PLUS_SIGNAL_SEARCH1_DRIVE			=$24;
	AISA59_MINUS_SIGNAL_SEARCH1_DRIVE			=$25;
	AISA59_PLUS_SIGNAL_SEARCH2_DRIVE			=$26;
	AISA59_MINUS_SIGNAL_SEARCH2_DRIVE			=$27;

	// Misc command
	AISA59_NO_OPERATION										=$17;
	AISA59_INPOSITION_WAIT_MODE_SET				=$18;
	AISA59_INPOSITION_WAIT_MODE_RESET			=$19;
	AISA59_ALARM_STOP_ENABLE_MODE_SET			=$1A;
	AISA59_ALARM_STOP_ENABLE_MODE_RESET		=$1B;
	AISA59_INTERRUPT_OUT_ENABLE_MODE_SET	=$1C;
	AISA59_INTERRUPT_OUT_ENABLE_MODE_RESET=$1D;
	AISA59_SLOW_DOWN_STOP									=$1E;
	AISA59_EMERGENCY_STOP									=$1F;

	// Misc
	AISA59_SLOT_AUTO											=$FFFF;
	AISA59_MAX_SLOTS											=16;
	AISA59_ERR_WRAPDLL										=DWord(-1);

	// Resource information
	AISA59_MAX_MEM												=9;
	AISA59_MAX_IO													=20;
	AISA59_MAX_IRQ												=7;
	AISA59_MAX_DMA												=7;

type
	TAISA59RESOURCE = record
		dwNumMemWindows:																DWord;	{ س޳(gp) }
		dwMemBase:			array [1 .. AISA59_MAX_MEM] of	DWord;	{ س޳ްڽ(gp) }
		dwMemLength:		array [1 .. AISA59_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwMemAttrib:		array [1 .. AISA59_MAX_MEM] of	DWord;	{ س޳(gp) }
		dwNumIOPorts:																		DWord;	{ I/O߰Đ }
		dwIOPortBase:		array [1 .. AISA59_MAX_IO] 	of	DWord;	{ I/O߰ްڽ }
		dwIOPortLength: array [1 .. AISA59_MAX_IO] 	of	DWord;	{ I/O߰Ē }
		dwNumIRQs:																			DWord;	{ IRQ }
		dwIRQRegisters: array [1 .. AISA59_MAX_IRQ] of	DWord;	{ IRQؽ }
		dwIRQAttrib:		array [1 .. AISA59_MAX_IRQ] of	DWord;	{ IRQؽ }
		dwNumDMAs:																			DWord;	{ DMAِ(gp) }
		dwDMALst:				array [1 .. AISA59_MAX_DMA] of	DWord;	{ DMAؽ(gp) }
		dwDMAAttrib:		array [1 .. AISA59_MAX_DMA] of	DWord;	{ DMAّؽ(gp) }
		dwReserved1:		array [1 .. 3] of								DWord;	{ \(gp) }
	end;

PAISA59R=^TAISA59RESOURCE;

//DLL [h
function Aisa59wDllOpen:Boolean;
//DLL A[h
function Aisa59wDllClose:Boolean;
//o[Wԍ擾
function Aisa59wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
//foCX̎gp錾
function Aisa59wCreate(var pwLogSlot:Word):Boolean;
//foCX̊J
function Aisa59wClose(wLogSlot:Word):Boolean;
//\[X擾
function Aisa59wGetResource(wLogSlot:Word;pres:PAISA59R):Boolean;
//ǂݍݎs
function Aisa59wInPort(wLogSlot:Word;wAxis:Word;wPort:Word;var pbData:Byte):Boolean;
//ݎs
function Aisa59wOutPort(wLogSlot:Word;wAxis:Word;wPort:Word;bData:Byte):Boolean;
//G[R[h擾
function Aisa59wGetLastError(wLogSlot:Word):DWord;
//hCuXe[^X擾
function Aisa59wGetDriveStatus(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;
//GhXe[^X擾
function Aisa59wGetEndStatus(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;
//JjJVOi擾
function Aisa59wGetMechanicalSignal(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;
//jo[TVOi擾
function Aisa59wGetUniversalSignal(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;
//[hP
function Aisa59wMode1Write(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;
//[hQ
function Aisa59wMode2Write(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;
//jo[TVOi
function Aisa59wUniversalSignalWrite(wLogSlot:Word;wAxis:Word;bSignal:Byte):Boolean;
//QoCgf[^ǂݍ
function Aisa59wDataHalfRead(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pwData:Word):Boolean;
//SoCgf[^ǂݍ
function Aisa59wDataFullRead(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pdwData:DWord):Boolean;
//R}h
function Aisa59wCommandWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte):Boolean;
//QoCgf[^
function Aisa59wDataHalfWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte;wData:Word):Boolean;
//SoCgf[^
function Aisa59wDataFullWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte;dwData:DWord):Boolean;

implementation

type
	TAisa59GetVersion						=function(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;stdcall;
	TAisa59Create							 	=function(var pwLogSlot:Word):Boolean;stdcall;
	TAisa59Close							 	=function(wLogSlot:Word):Boolean;stdcall;
	TAisa59GetResource          =function(wLogSlot:Word;pres:PAISA59R):Boolean;stdcall;
	TAisa59InPort								=function(wLogSlot:Word;wAxis:Word;wPort:Word;var pbData:Byte):Boolean;stdcall;
	TAisa59OutPort							=function(wLogSlot:Word;wAxis:Word;wPort:Word;bData:Byte):Boolean;stdcall;
	TAisa59GetLastError					=function(wLogSlot:Word):Word;stdcall;
	TAisa59GetDriveStatus       =function(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;stdcall;
	TAisa59GetEndStatus         =function(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;stdcall;
	TAisa59GetMechanicalSignal  =function(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;stdcall;
	TAisa59GetUniversalSignal   =function(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;stdcall;
	TAisa59Mode1Write           =function(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;stdcall;
	TAisa59Mode2Write           =function(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;stdcall;
	TAisa59UniversalSignalWrite	=function(wLogSlot:Word;wAxis:Word;bSignal:Byte):Boolean;stdcall;
	TAisa59DataHalfRead         =function(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pwData:Word):Boolean;stdcall;
	TAisa59DataFullRead         =function(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pdwData:DWord):Boolean;stdcall;
	TAisa59CommandWrite         =function(wLogSlot:Word;wAxis:Word;bCmd:Byte):Boolean;stdcall;
	TAisa59DataHalfWrite        =function(wLogSlot:Word;wAxis:Word;bCmd:Byte;wData:Word):Boolean;stdcall;
	TAisa59DataFullWrite        =function(wLogSlot:Word;wAxis:Word;bCmd:Byte;dwData:DWord):Boolean;stdcall;

function Aisa59wGetDllExportFunc:Boolean;forward;

{$J+}
const
	hDLL: THandle = 0;
{$J-}

// DLLGNX|[g֐AhX̊i[ϐ
var
	pAisa59GetVersion:					TAisa59GetVersion;
	pAisa59Create:							TAisa59Create;
	pAisa59Close:								TAisa59Close;
	pAisa59GetResource:					TAisa59GetResource;
	pAisa59InPort:							TAisa59InPort;
	pAisa59OutPort:							TAisa59OutPort;
	pAisa59GetLastError:				TAisa59GetLastError;
	pAisa59GetDriveStatus:			TAisa59GetDriveStatus;
	pAisa59GetEndStatus:				TAisa59GetEndStatus;
	pAisa59GetMechanicalSignal:	TAisa59GetMechanicalSignal;
	pAisa59GetUniversalSignal:	TAisa59GetUniversalSignal;
	pAisa59Mode1Write:					TAisa59Mode1Write;
	pAisa59Mode2Write:					TAisa59Mode2Write;
	pAisa59UniversalSignalWrite:TAisa59UniversalSignalWrite;
	pAisa59DataHalfRead:				TAisa59DataHalfRead;
	pAisa59DataFullRead:				TAisa59DataFullRead;
	pAisa59CommandWrite:				TAisa59CommandWrite;
	pAisa59DataHalfWrite:				TAisa59DataHalfWrite;
	pAisa59DataFullWrite:				TAisa59DataFullWrite;
//===================================================================
//   	Aisa59.dll [h
//   	
// ߂l  True
//				s False
//===================================================================
function Aisa59wDllOpen:Boolean;
begin
	Result:=False;
	if hDLL <> 0 then Exit;
	hDLL := LoadLibrary(AISA59_DLL_NAME);
	if hDLL = 0 then Exit;
	if Aisa59wGetDllExportFunc = False then	begin
		Aisa59wDllClose;	// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Exit;
	end;
	Result := True;
end;
//===================================================================
//   	Aisa59.dllA[h
//   	
// ߂l  True
//				s False
//===================================================================
function Aisa59wDllClose: Boolean;
begin
	Result := True;
	if hDLL = 0 then Exit;
	if FreeLibrary(hDLL) = True then hDLL := 0
	else Result := False;
end;
//===================================================================
//    o[Wԍ擾
//    pdwDllVer	DLLo[Wԍi[
//        pdwDrvVer	DRVo[Wԍi[
// ߂l  True
//				s False
//===================================================================
function Aisa59wGetVersion(var pdwDllVer:DWord; var pdwDrvVer:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59GetVersion(pdwDllVer,pdwDrvVer);
end;
//===================================================================
//    foCX̎gp錾
//    pwLogSlot gpfoCXi[
// ߂l  True
//				s False
//===================================================================
function Aisa59wCreate(var pwLogSlot:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59Create(pwLogSlot);
end;
//===================================================================
//    foCX̊J
//    wLogSlot	gpfoCX
// ߂l  True
//				s False
//===================================================================
function Aisa59wClose(wLogSlot:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59Close(wLogSlot);
end;
//===================================================================
//    wfoCX̃\[X擾
//    wLogSlot	foCX
//        pres			\[Xi[\
// ߂l  True
//				s False
//===================================================================
function Aisa59wGetResource(wLogSlot:Word;pres:PAISA59R):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59GetResource(wLogSlot,pres);
end;
//===================================================================
//    wfoCXɑ΂ǂݍݎs
//    wLogSlot		foCX
//        wAxis				Ώې䎲
//        wPort				|[gԍiO`Vj
//        pbData			̓f[^i[
// ߂l  True
//        s False
//===================================================================
function Aisa59wInPort(wLogSlot:Word;wAxis:Word;wPort:Word;var pbData:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59InPort(wLogSlot,wAxis,wPort,pbData);
end;
//===================================================================
//    wfoCXɑ΂ݎs
//    wLogSlot		foCX
//        wAxis				Ώې䎲
//        wPort				|[gԍiO`Vj
//        bData				o̓f[^
// ߂l  True
//        s False
//===================================================================
function Aisa59wOutPort(wLogSlot:Word;wAxis:Word;wPort:Word;bData:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59OutPort(wLogSlot,wAxis,wPort,bData);
end;
//===================================================================
//    G[R[h擾
//    wLogSlot		foCX
// ߂l  True
//        s False
//===================================================================
function Aisa59wGetLastError(wLogSlot:Word):DWord;
begin
	Result := AISA59_ERR_WRAPDLL;
	if hDLL = 0 then Exit;
	Result := pAisa59GetLastError(wLogSlot);
end;
//===================================================================
//    hCuXe[^X擾
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        pbStatus  Xe[^Xi[
// ߂l  True
//				s False
//===================================================================
function Aisa59wGetDriveStatus(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59GetDriveStatus(wLogSlot, wAxis, pbStatus);
end;
//===================================================================
//    GhXe[^X擾
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        pbStatus  Xe[^Xi[
// ߂l  True
//				s False
//===================================================================
function Aisa59wGetEndStatus(wLogSlot:Word;wAxis:Word;var pbStatus:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59GetEndStatus(wLogSlot, wAxis, pbStatus);
end;
//===================================================================
//    JjJVOi擾
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        pbSignal  VOii[
// ߂l  True
//				s False
//===================================================================
function Aisa59wGetMechanicalSignal(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59GetMechanicalSignal(wLogSlot, wAxis, pbSignal);
end;
//===================================================================
//    jo[TVOi擾
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        pbSignal  VOii[
// ߂l  True
//				s False
//===================================================================
function Aisa59wGetUniversalSignal(wLogSlot:Word;wAxis:Word;var pbSignal:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59GetUniversalSignal(wLogSlot, wAxis, pbSignal);
end;
//===================================================================
//    [hP
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bMode  		[hl
// ߂l  True
//				s False
//===================================================================
function Aisa59wMode1Write(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59Mode1Write(wLogSlot, wAxis, bMode);
end;
//===================================================================
//    [hQ
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bMode  		[hl
// ߂l  True
//				s False
//===================================================================
function Aisa59wMode2Write(wLogSlot:Word;wAxis:Word;bMode:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59Mode2Write(wLogSlot, wAxis, bMode);
end;
//===================================================================
//    jo[TVOi
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bSignal  	VOil
// ߂l  True
//				s False
//===================================================================
function Aisa59wUniversalSignalWrite(wLogSlot:Word;wAxis:Word;bSignal:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59UniversalSignalWrite(wLogSlot, wAxis, bSignal);
end;
//===================================================================
//    QoCgf[^ǂݍ
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bCmd  		R}h
//				pwData		f[^i[
// ߂l  True
//				s False
//===================================================================
function Aisa59wDataHalfRead(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pwData:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59DataHalfRead(wLogSlot, wAxis, bCmd, pwData);
end;
//===================================================================
//    SoCgf[^ǂݍ
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bCmd  		R}h
//				pdwData		f[^i[
// ߂l  True
//				s False
//===================================================================
function Aisa59wDataFullRead(wLogSlot:Word;wAxis:Word;bCmd:Byte;var pdwData:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59DataFullRead(wLogSlot, wAxis, bCmd, pdwData);
end;
//===================================================================
//    R}h
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bCmd  		R}h
// ߂l  True
//				s False
//===================================================================
function Aisa59wCommandWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59CommandWrite(wLogSlot, wAxis, bCmd);
end;
//===================================================================
//    QoCgf[^
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bCmd  		R}h
//        wData     f[^
// ߂l  True
//				s False
//===================================================================
function Aisa59wDataHalfWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte;wData:Word):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59DataHalfWrite(wLogSlot, wAxis, bCmd, wData);
end;
//===================================================================
//    SoCgf[^
//    wLogSlot	foCX
//        wAxis			Ώې䎲
//        bCmd  		R}h
//        dwData    f[^
// ߂l  True
//				s False
//===================================================================
function Aisa59wDataFullWrite(wLogSlot:Word;wAxis:Word;bCmd:Byte;dwData:DWord):Boolean;
begin
	Result := False;
	if hDLL = 0 then Exit;
	Result := pAisa59DataFullWrite(wLogSlot, wAxis, bCmd, dwData);
end;
//-------------------------------------------------------------------
//    DLLGNX|[g֐AhX̎擾
//    
// ߂l  True
//				s False
//-------------------------------------------------------------------
function Aisa59wGetDllExportFunc:Boolean;
begin
	Result := False;

	pAisa59GetVersion						:= GetProcAddress(hDLL,'Aisa59GetVersion');
	if @pAisa59GetVersion 					= nil then Exit;
	pAisa59Create								:= GetProcAddress(hDLL,'Aisa59Create');
	if @pAisa59Create 							= nil then Exit;
	pAisa59Close								:= GetProcAddress(hDLL,'Aisa59Close');
	if @pAisa59Close 								= nil then Exit;
	pAisa59GetResource					:= GetProcAddress(hDLL,'Aisa59GetResource');
	if @pAisa59GetResource 					= nil then Exit;
	pAisa59InPort								:= GetProcAddress(hDLL,'Aisa59InPort');
	if @pAisa59InPort			 					= nil then Exit;
	pAisa59OutPort							:= GetProcAddress(hDLL,'Aisa59OutPort');
	if @pAisa59OutPort							= nil then Exit;
	pAisa59GetLastError					:= GetProcAddress(hDLL,'Aisa59GetLastError');
	if @pAisa59GetLastError					= nil then Exit;
	pAisa59GetDriveStatus				:= GetProcAddress(hDLL,'Aisa59GetDriveStatus');
	if @pAisa59GetDriveStatus 			= nil then Exit;
	pAisa59GetEndStatus					:= GetProcAddress(hDLL,'Aisa59GetEndStatus');
	if @pAisa59GetEndStatus 				= nil then Exit;
	pAisa59GetMechanicalSignal	:= GetProcAddress(hDLL,'Aisa59GetMechanicalSignal');
	if @pAisa59GetMechanicalSignal 	= nil then Exit;
	pAisa59GetUniversalSignal		:= GetProcAddress(hDLL,'Aisa59GetUniversalSignal');
	if @pAisa59GetUniversalSignal	 	= nil then Exit;
	pAisa59Mode1Write						:= GetProcAddress(hDLL,'Aisa59Mode1Write');
	if @pAisa59Mode1Write 					= nil then Exit;
	pAisa59Mode2Write						:= GetProcAddress(hDLL,'Aisa59Mode2Write');
	if @pAisa59Mode2Write 					= nil then Exit;
	pAisa59UniversalSignalWrite	:= GetProcAddress(hDLL,'Aisa59UniversalSignalWrite');
	if @pAisa59UniversalSignalWrite = nil then Exit;
	pAisa59DataHalfRead					:= GetProcAddress(hDLL,'Aisa59DataHalfRead');
	if @pAisa59DataHalfRead 				= nil then Exit;
	pAisa59DataFullRead					:= GetProcAddress(hDLL,'Aisa59DataFullRead');
	if @pAisa59DataFullRead 				= nil then Exit;
	pAisa59CommandWrite					:= GetProcAddress(hDLL,'Aisa59CommandWrite');
	if @pAisa59CommandWrite 				= nil then Exit;
	pAisa59DataHalfWrite				:= GetProcAddress(hDLL,'Aisa59DataHalfWrite');
	if @pAisa59DataHalfWrite 				= nil then Exit;
	pAisa59DataFullWrite				:= GetProcAddress(hDLL,'Aisa59DataFullWrite');
	if @pAisa59DataFullWrite 				= nil then Exit;

	Result := True;	// SĂ DLL GNX|[g֐AhX擾
end;

end.

