#ifndef	_AISA59_H_
#define _AISA59_H_

#ifdef __cplusplus
extern "C" {
#endif

#define AISA59_SLOT_AUTO						((WORD)~0U)
#define AISA59_MAX_SLOTS						16
//-------------------------------------------------------------------
// 䎲
//-------------------------------------------------------------------
#define AISA59_AXIS_1							0
#define AISA59_AXIS_2							1
#define AISA59_AXIS_3							2
#define AISA59_AXIS_4							3
//-------------------------------------------------------------------
// I/O }bv
//-------------------------------------------------------------------
#define AISA59_PORT_DATA1						0x00
#define AISA59_PORT_DATA2						0x01
#define AISA59_PORT_DATA3						0x02
#define AISA59_PORT_DATA4						0x03
#define AISA59_PORT_COMMAND						0x04
#define AISA59_PORT_MODE1						0x05
#define AISA59_PORT_MODE2						0x06
#define AISA59_PORT_UNIVERSAL_SIGNAL			0x07
#define AISA59_PORT_DRIVE_STATUS				0x04
#define AISA59_PORT_END_STATUS					0x05
#define AISA59_PORT_MECHANICAL_SIGNAL			0x06
//-------------------------------------------------------------------
// ݃R}h
//-------------------------------------------------------------------
#define AISA59_RANGE_WRITE						0x00
#define AISA59_START_STOP_SPEED_DATA_WRITE		0x02
#define AISA59_OBJECT_SPEED_DATA_WRITE			0x04
#define AISA59_RATE1_DATA_WRITE					0x06
#define AISA59_RATE2_DATA_WRITE					0x08
#define AISA59_RATE3_DATA_WRITE					0x0A
#define AISA59_RATE_CHANGE_POINT_1_2_WRITE		0x0C
#define AISA59_RATE_CHANGE_POINT_2_3_WRITE		0x0E
#define AISA59_SLOW_DOWN_REAR_PULSE_WRITE		0x10
#define AISA59_PRESET_PULSE_DATA_OVERRIDE		0x14
#define AISA59_INTERNAL_COUNTER_WRITE			0x28
#define AISA59_INTERNAL_COMPARATE_DATA_WRITE	0x2A
#define AISA59_EXTERNAL_COUNTER_WRITE			0x2C
#define AISA59_EXTERNAL_COMPARATE_DATA_WRITE	0x2D
//-------------------------------------------------------------------
// ǂݍ݃R}h
//-------------------------------------------------------------------
#define AISA59_RANGE_READ						0x01
#define AISA59_START_STOP_SPEED_DATA_READ		0x03
#define AISA59_OBJECT_SPEED_DATA_READ			0x05
#define AISA59_RATE1_DATA_READ					0x07
#define AISA59_RATE2_DATA_READ					0x09
#define AISA59_RATE3_DATA_READ					0x0B
#define AISA59_RATE_CHANGE_POINT_1_2_READ		0x0D
#define AISA59_RATE_CHANGE_POINT_2_3_READ		0x0F
#define AISA59_SLOW_DOWN_REAR_PULSE_READ		0x11
#define AISA59_NOW_SPEED_DATA_READ				0x12
#define AISA59_DRIVE_PULSE_COUNTER_READ			0x13
#define AISA59_PRESET_PULSE_DATA_READ			0x15
#define AISA59_DEVIATION_DATA_READ				0x16
#define AISA59_INTERNAL_COUNTER_READ			0x29
#define AISA59_INTERNAL_COMPARATE_DATA_READ		0x2B
#define AISA59_EXTERNAL_COUNTER_READ			0x2D
#define AISA59_EXTERNAL_COMPARATE_DATA_READ		0x2F
//-------------------------------------------------------------------
// hCuR}h
//-------------------------------------------------------------------
#define AISA59_PLUS_PRESET_PULSE_DRIVE			0x20
#define AISA59_MINUS_PRESET_PULSE_DRIVE			0x21
#define AISA59_PLUS_CONTINUOUS_DRIVE			0x22
#define AISA59_MINUS_CONTINUOUS_DRIVE			0x23
#define AISA59_PLUS_SIGNAL_SEARCH1_DRIVE		0x24
#define AISA59_MINUS_SIGNAL_SEARCH1_DRIVE		0x25
#define AISA59_PLUS_SIGNAL_SEARCH2_DRIVE		0x26
#define AISA59_MINUS_SIGNAL_SEARCH2_DRIVE		0x27
//-------------------------------------------------------------------
// ̑̃R}h
//-------------------------------------------------------------------
#define AISA59_NO_OPERATION						0x17
#define AISA59_INPOSITION_WAIT_MODE_SET			0x18
#define AISA59_INPOSITION_WAIT_MODE_RESET		0x19
#define AISA59_ALARM_STOP_ENABLE_MODE_SET		0x1A
#define AISA59_ALARM_STOP_ENABLE_MODE_RESET		0x1B
#define AISA59_INTERRUPT_OUT_ENABLE_MODE_SET	0x1C
#define AISA59_INTERRUPT_OUT_ENABLE_MODE_RESET	0x1D
#define AISA59_SLOW_DOWN_STOP					0x1E
#define AISA59_EMERGENCY_STOP					0x1F
//-------------------------------------------------------------------
// \[X\
//-------------------------------------------------------------------
#define AISA59_MAX_MEM							9
#define AISA59_MAX_IO							20
#define AISA59_MAX_IRQ							7
#define AISA59_MAX_DMA							7

typedef struct {
    DWORD   dwNumMemWindows;					// Not used
    DWORD   dwMemBase       [AISA59_MAX_MEM];	// Not used
    DWORD   dwMemLength     [AISA59_MAX_MEM];	// Not used
    DWORD   dwMemAttrib     [AISA59_MAX_MEM];	// Not used
    DWORD   dwNumIOPorts;						// Num IO ports
    DWORD   dwIOPortBase    [AISA59_MAX_IO];	// I/O port base
    DWORD   dwIOPortLength  [AISA59_MAX_IO];	// I/O port length
    DWORD   dwNumIRQs;							// Not used
    DWORD   dwIRQRegisters  [AISA59_MAX_IRQ];	// Not used
    DWORD   dwIRQAttrib     [AISA59_MAX_IRQ];	// Not used
	DWORD	dwNumDMAs;							// Not used
    DWORD   dwDMALst        [AISA59_MAX_DMA];	// Not used
    DWORD   dwDMAAttrib     [AISA59_MAX_DMA];	// Not used
    DWORD   dwReserved1     [3];				// Not used
} AISA59RESOURCE, *PAISA59R;
//-------------------------------------------------------------------
// G[R[h
//-------------------------------------------------------------------
#define AISA59_SUCCESS							0  // ُȂiIj
#define AISA59_ERR_SYSTEM						1  // Windows  GetLastError()R[Ă
#define AISA59_ERR_NO_DEVICE					2  // gp\ȃfoCX܂
#define AISA59_ERR_IN_USE						3  // w̃foCX͎gpł
#define AISA59_ERR_INVALID_SLOT					4  // Ș_Xbgł
#define AISA59_ERR_RESOURCE						5  // \[XG[
#define AISA59_ERR_INVALID_PORT					6  // sȃ|[gv
#define AISA59_ERR_INVALID_ARGUMENT				7  // sȈv܂
#define AISA59_ERR_INVALID_AXIS					50 // Ȑ䎲v

#ifdef __cplusplus
}
#endif
#endif
