//===================================================================
// aISA59s.c
//-------------------------------------------------------------------
// aISA-M59
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// Date Dec.1998
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "Aisa59w.h"

const TCHAR szTitle[]	= _T("Sample");
const TCHAR szAisa59[]	= _T("aISA-M59");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);
static BOOL Aisa59_InitAxis(WORD wLogSlot,WORD wAxis);

//===================================================================
// C
//===================================================================
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
												LPSTR lpCmdLine, int nCmdShow)
{
	TCHAR			szBuf[1024];
	DWORD			dwDllVer, dwDrvVer;
	WORD			wLogSlot, wAxis;
	AISA59RESOURCE	ri;
	BYTE			b;
	DWORD			dwCount;

	//---------------------------------------------------------------
	// Aisa59.Dll J
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wDllOpen() ) {
		ErrorMessage(AISA59_SLOT_AUTO);
		return 1;						// DLL̃[hɎs܂
	}
	//---------------------------------------------------------------
	// o[W̕\
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wGetVersion(&dwDllVer,&dwDrvVer)) {
		ErrorMessage(AISA59_SLOT_AUTO);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("Dll Version %08lx\n")
		_T("Drv Version %08lx"),
		dwDllVer,dwDrvVer );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------
	wLogSlot = AISA59_SLOT_AUTO;		// 󂫃foCXw
	if ( FALSE == Aisa59wCreate(&wLogSlot) ){
		ErrorMessage(AISA59_SLOT_AUTO);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59 Created\n")
		_T("LogSlot %d"), wLogSlot );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// \[X\
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wGetResource(wLogSlot,&ri)){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf, _T("Board  Name: %s\n")
					_T("IO Address : %04xh-%04xh\n"),
					szAisa59,
					ri.dwIOPortBase[0],ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1 );
	ResultMessage(szBuf);
	//---------------------------------------------------------------
	// PI
	//---------------------------------------------------------------
	wAxis = AISA59_AXIS_1;
	//---------------------------------------------------------------
	// 䎲̏
	//---------------------------------------------------------------
	if ( FALSE == Aisa59_InitAxis(wLogSlot,wAxis)){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("䎲 %d ܂"), wAxis );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// { 1000 pXo
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wDataFullWrite( 
		wLogSlot, wAxis, AISA59_PLUS_PRESET_PULSE_DRIVE, 1000 ) ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("{ 1000pXo͂Ă܂"));
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// hCuXe[^X擾
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wGetDriveStatus( wLogSlot, wAxis, &b ) ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	//---------------------------------------------------------------
	// rW[tOĂihCuȂj~
	//---------------------------------------------------------------
	if ( b & 0x01 ) {
		if ( FALSE == Aisa59wCommandWrite( wLogSlot, wAxis, AISA59_SLOW_DOWN_STOP ) ){
			ErrorMessage(wLogSlot);
			return 1;
		}
		wsprintf( szBuf,
			_T("aISA-M59\n")
			_T("~܂"));
		ResultMessage( szBuf );
	}
	//---------------------------------------------------------------
	// GhXe[^X擾
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wGetEndStatus( wLogSlot, wAxis, &b ) ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("GhXe[^X: %Xh"),b);
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// JE^[\
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wDataFullRead(
		wLogSlot, wAxis, AISA59_INTERNAL_COUNTER_READ, &dwCount ) ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	//---------------------------------------------------------------
	// g
	//---------------------------------------------------------------
	if ( dwCount & 0x08000000 ) dwCount |= 0xF0000000;
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("JE^[: %d"),dwCount);
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// JjJVOi\
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wGetMechanicalSignal( wLogSlot, wAxis, &b ) ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("JjJVOi: %Xh"),b);
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// jo[TVOi\
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wGetUniversalSignal( wLogSlot, wAxis, &b ) ) {
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59\n")
		_T("jo[TVOi: %Xh"),b);
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// foCX
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wClose(wLogSlot)){
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf( szBuf,
		_T("aISA-M59 Close\n")
		_T("LogSlot %d"), wLogSlot );
	ResultMessage( szBuf );
	//---------------------------------------------------------------
	// Aisa59.Dll 
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wDllClose()) {
		ErrorMessage(AISA59_SLOT_AUTO);
		return 1;						// DLL̃A[hɎs܂
	}

	return 0;
}
//-------------------------------------------------------------------
// 䎲̏
//-------------------------------------------------------------------
//   		wLogSlot	foCXԍ
//				wAxis		䎲
//             	AISA59_AXIS_1 ` AISA59_AXIS_4 w肵܂
//-------------------------------------------------------------------
static BOOL Aisa59_InitAxis(WORD wLogSlot,WORD wAxis)
{
	//---------------------------------------------------------------
	// MODE1 SET
	//
	// Jn|Cgo				
	// pXo͕						QpX
	// DIR   o͒[q 						CWpX  ANeBu Hi
	// PULSE o͒[q						CCWpX ANeBu Hi
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wMode1Write(wLogSlot,wAxis,0x40)) return FALSE;
	//---------------------------------------------------------------
	// MODE2 SET
	//
	// EXTERNAL COUNTER ͎dl			QMS{
	// DEND ͐MANeBux		Low
	// DERR ͐MANeBux		Low
	// -SLM ͐MANeBux		Low
	// +SLM ͐MANeBux		Low
	// -ELM ͐MANeBux		Low
	// +ELM ͐MANeBux		Low
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wMode2Write(wLogSlot,wAxis,0xFF)) return FALSE;
	//---------------------------------------------------------------
	// [hݒ
	//
	// INPOSITION WAIT MODE RESET
	// ALARM STOP ENABLE MODE SET
	// INTERRUPT OUT ENABLE MODE RESET
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wCommandWrite(
		wLogSlot,wAxis,AISA59_INPOSITION_WAIT_MODE_RESET))
		return FALSE;
	if ( FALSE == Aisa59wCommandWrite(
		wLogSlot,wAxis,AISA59_ALARM_STOP_ENABLE_MODE_SET)) return FALSE;
	if ( FALSE == Aisa59wCommandWrite(
		wLogSlot,wAxis,AISA59_INTERRUPT_OUT_ENABLE_MODE_RESET)) return FALSE;
	//---------------------------------------------------------------
	// f[^ݒ
	//
	// RANGE DATA				50		o͎gݒP 	50050=10PPS
	// START/STOP SPEED DATA	100		Jn~g 		100~10PPS=1000PPS
	// OBJECT SPEED DATA		4000	ړIg 			4000~10PPS=40000PPS
	// RATE-1 DATA              1024	ԐݒP 	1024(2.048~10^6)=0.5mSec
	//									 			(4000-100)~0.5mSec = 1.95Sec
	// RATE-2 DATA        				ftHgl 8191(1FFFh)
	// RATE-3 DATA						ftHgl 8191(1FFFh)
	// RATE CHANGE POINT 1-2			ftHgl 8191(1FFFh)
	// RATE CHANGE POINT 2-3			ftHgl 8191(1FFFh)
	//
	// ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wDataHalfWrite(
		wLogSlot,wAxis,AISA59_RANGE_WRITE,50)) return FALSE;
	if ( FALSE == Aisa59wDataHalfWrite(
		wLogSlot,wAxis,AISA59_START_STOP_SPEED_DATA_WRITE,100)) return FALSE;
	if ( FALSE == Aisa59wDataFullWrite(
		wLogSlot,wAxis,AISA59_OBJECT_SPEED_DATA_WRITE,4000)) return FALSE;
	if ( FALSE == Aisa59wDataFullWrite(
		wLogSlot,wAxis,AISA59_RATE1_DATA_WRITE,1024)) return FALSE;
	//---------------------------------------------------------------
	// AhXݒ
	//
	// INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
	//---------------------------------------------------------------
	if ( FALSE == Aisa59wDataFullWrite(
		wLogSlot,wAxis,AISA59_INTERNAL_COUNTER_WRITE,0)) return FALSE;
	if ( FALSE == Aisa59wDataFullWrite(
		wLogSlot,wAxis,AISA59_EXTERNAL_COUNTER_WRITE,0)) return FALSE;

	return TRUE;
}
//-------------------------------------------------------------------
// ʂ\
//-------------------------------------------------------------------
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}
//-------------------------------------------------------------------
// G[bZ[W\
//-------------------------------------------------------------------
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa59wGetLastError(wLogSlot);
	TCHAR szbuf[50];

	switch (dwRes) {
		case AISA59_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"), GetLastError());
			break;

		case AISA59_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-M59 error\n\n")
							_T("Error code: %08lxh"), dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
