//===================================================================
// aISA59w.c
//-------------------------------------------------------------------
// aISA-M59
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
// 
// Date Dec.1998
//===================================================================
#include <windows.h>
#include <tchar.h>
#include "Aisa59w.h"

// -- X^eBbN֐ & X^eBbNϐi萔j
static BOOL Aisa59wGetDllExportFunc( VOID );
static HANDLE hDLL = NULL;
// -- GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa59GetVersion;
static FARPROC pAisa59Create;
static FARPROC pAisa59Close;
static FARPROC pAisa59GetResource;
static FARPROC pAisa59InPort;
static FARPROC pAisa59OutPort;
static FARPROC pAisa59GetLastError;
static FARPROC pAisa59GetDriveStatus;
static FARPROC pAisa59GetEndStatus;
static FARPROC pAisa59GetMechanicalSignal;
static FARPROC pAisa59GetUniversalSignal;
static FARPROC pAisa59Mode1Write;
static FARPROC pAisa59Mode2Write;
static FARPROC pAisa59UniversalSignalWrite;
static FARPROC pAisa59DataHalfRead;
static FARPROC pAisa59DataFullRead;
static FARPROC pAisa59CommandWrite;
static FARPROC pAisa59DataHalfWrite;
static FARPROC pAisa59DataFullWrite;

//===================================================================
//   		DLL [h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wDllOpen( VOID )
{
	if ( hDLL != NULL ) return FALSE;
	hDLL = (HMODULE)LoadLibrary(AISA59_DLL_NAME);
	if ( hDLL == NULL ) return FALSE;
	if ( Aisa59wGetDllExportFunc() == FALSE ) {
		Aisa59wDllClose();
		return FALSE;
	}
	return TRUE;
}
//===================================================================
//   		DLL A[h
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wDllClose( VOID )
{
	if ( hDLL == NULL ) return FALSE;
	if ( FreeLibrary(hDLL) == TRUE ) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}
//===================================================================
//   		o[Wԍ擾
//   		pdwDllVersion	DLL o[Wi[̈ւ̃|C^
//				pdwDrvVersion	DRV o[Wi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wGetVersion( PDWORD pdwDllVersion, PDWORD pdwDrvVersion)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59GetVersion)(pdwDllVersion,pdwDrvVersion);
}
//===================================================================
//   		foCX̎gp錾
//   		pwLogSlot		foCXi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wCreate( PWORD pwLogSlot )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59Create)(pwLogSlot);
}
//===================================================================
//   		foCX̉
//   		wLogSlot		foCX
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wClose(WORD wLogSlot)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59Close)(wLogSlot);
}
//===================================================================
//   		\[X擾
//   		wLogSlot		foCX
//				pres			\[Xi[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wGetResource(WORD wLogSlot, PAISA59R pres)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59GetResource)(wLogSlot,pres);
}
//===================================================================
//   		ǂݍݎs
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				wPort			Ώۃ|[gԍ
//				pbData			ǂݍ񂾃f[^i[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wInPort( WORD wLogSlot, WORD wAxis ,WORD wPort, PBYTE pbData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59InPort)(wLogSlot,wAxis,wPort,pbData);
}
//===================================================================
//   		ݎs
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				wPort			Ώۃ|[gԍ
//				bData			ޒl
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wOutPort( WORD wLogSlot, WORD wAxis ,WORD wPort, BYTE bData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59OutPort)(wLogSlot,wAxis,wPort,bData);
}
//===================================================================
//   		hCuXe[^X擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbStatus		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wGetDriveStatus( WORD wLogSlot, WORD wAxis, PBYTE pbStatus)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59GetDriveStatus)(wLogSlot,wAxis,pbStatus);
}
//===================================================================
//   		GhXe[^X擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbStatus		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wGetEndStatus( WORD wLogSlot, WORD wAxis, PBYTE pbStatus)
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59GetEndStatus)(wLogSlot,wAxis,pbStatus);
}
//===================================================================
//   		JjJVOi擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbSignal		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wGetMechanicalSignal( WORD wLogSlot, WORD wAxis, PBYTE pbSignal )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59GetMechanicalSignal)(wLogSlot,wAxis,pbSignal);
}
//===================================================================
//   		jo[TVOi擾
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				pbSignal		i[̈ւ̃|C^	
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wGetUniversalSignal( WORD wLogSlot, WORD wAxis, PBYTE pbSignal )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59GetUniversalSignal)(wLogSlot,wAxis,pbSignal);
}
//===================================================================
//   		[hP
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bMode			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wMode1Write( WORD wLogSlot, WORD wAxis, BYTE bMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59Mode1Write)(wLogSlot,wAxis,bMode);
}
//===================================================================
//   		[hQ
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bMode			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wMode2Write( WORD wLogSlot, WORD wAxis, BYTE bMode )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59Mode2Write)(wLogSlot,wAxis,bMode);
}
//===================================================================
//   		jo[TVOi
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bSignal			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wUniversalSignalWrite( WORD wLogSlot, WORD wAxis, BYTE bSignal )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59UniversalSignalWrite)(wLogSlot,wAxis,bSignal);
}
//===================================================================
//   		QoCgf[^ǂݍ
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ǂݍݎɎsR}h
//				pwData			ǂݍ񂾃f[^i[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wDataHalfRead( WORD wLogSlot, WORD wAxis, BYTE bCmd, PWORD pwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59DataHalfRead)(wLogSlot,wAxis,bCmd,pwData);
}
//===================================================================
//   		SoCgf[^ǂݍ
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ǂݍݎɎsR}h
//				pdwData			ǂݍ񂾃f[^i[̈ւ̃|C^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wDataFullRead( WORD wLogSlot, WORD wAxis, BYTE bCmd, PDWORD pdwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59DataFullRead)(wLogSlot,wAxis,bCmd,pdwData);
}
//===================================================================
//   		R}h
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			R}h
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wCommandWrite( WORD wLogSlot, WORD wAxis, BYTE bCmd )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59CommandWrite)(wLogSlot,wAxis,bCmd);
}
//===================================================================
//   		QoCgf[^
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ݎɎsR}h
//				wData			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wDataHalfWrite( WORD wLogSlot, WORD wAxis, BYTE bCmd, WORD wData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59DataHalfWrite)(wLogSlot,wAxis,bCmd,wData);
}
//===================================================================
//   		SoCgf[^
//   		wLogSlot		foCX
//				wAxis			Ώې䎲
//				bCmd			ݎɎsR}h
//				dwData			ރf[^
// ߂l		TRUE	
//				FALSE	s
//===================================================================
BOOL Aisa59wDataFullWrite( WORD wLogSlot, WORD wAxis, BYTE bCmd, DWORD dwData )
{
	if ( hDLL == NULL ) return FALSE;
	return (*pAisa59DataFullWrite)(wLogSlot,wAxis,bCmd,dwData);
}
//===================================================================
//   		G[R[h擾
//   		wLogSlot		foCX
// ߂l		G[R[h
//===================================================================
DWORD Aisa59wGetLastError( WORD wLogSlot )
{
	if ( hDLL == NULL ) return AISA59_ERR_WRAPDLL;
	return (*pAisa59GetLastError)(wLogSlot);
}
//-------------------------------------------------------------------
//   		DLLGNX|[g֐AhX̎擾
//   		Ȃ
// ߂l		TRUE	
//				FALSE	s
//-------------------------------------------------------------------
static BOOL Aisa59wGetDllExportFunc( VOID )
{
	pAisa59GetVersion = GetProcAddress( hDLL, _T("Aisa59GetVersion"));
	if ( pAisa59GetVersion == NULL ) return FALSE;
	pAisa59Create = GetProcAddress( hDLL, _T("Aisa59Create"));
	if ( pAisa59Create == NULL ) return FALSE;
	pAisa59Close = GetProcAddress( hDLL, _T("Aisa59Close"));
	if ( pAisa59Close == NULL ) return FALSE;
	pAisa59GetResource = GetProcAddress( hDLL, _T("Aisa59GetResource"));
	if ( pAisa59GetResource == NULL ) return FALSE;
	pAisa59InPort = GetProcAddress( hDLL, _T("Aisa59InPort"));
	if ( pAisa59InPort == NULL ) return FALSE;
	pAisa59OutPort = GetProcAddress( hDLL, _T("Aisa59OutPort"));
	if ( pAisa59OutPort == NULL ) return FALSE;
	pAisa59GetLastError = GetProcAddress( hDLL, _T("Aisa59GetLastError"));
	if ( pAisa59GetLastError == NULL ) return FALSE;
	pAisa59GetDriveStatus = GetProcAddress( hDLL, _T("Aisa59GetDriveStatus"));
	if ( pAisa59GetDriveStatus == NULL ) return FALSE;
	pAisa59GetEndStatus = GetProcAddress( hDLL, _T("Aisa59GetEndStatus"));
	if ( pAisa59GetEndStatus == NULL ) return FALSE;
	pAisa59GetMechanicalSignal = GetProcAddress( hDLL, _T("Aisa59GetMechanicalSignal"));
	if ( pAisa59GetMechanicalSignal == NULL ) return FALSE;
	pAisa59GetUniversalSignal = GetProcAddress( hDLL, _T("Aisa59GetUniversalSignal"));
	if ( pAisa59GetUniversalSignal == NULL ) return FALSE;
	pAisa59Mode1Write = GetProcAddress( hDLL, _T("Aisa59Mode1Write"));
	if ( pAisa59Mode1Write == NULL ) return FALSE;
	pAisa59Mode2Write = GetProcAddress( hDLL, _T("Aisa59Mode2Write"));
	if ( pAisa59Mode2Write == NULL ) return FALSE;
	pAisa59UniversalSignalWrite = GetProcAddress( hDLL, _T("Aisa59UniversalSignalWrite"));
	if ( pAisa59UniversalSignalWrite == NULL ) return FALSE;
	pAisa59DataHalfRead = GetProcAddress( hDLL, _T("Aisa59DataHalfRead"));
	if ( pAisa59DataHalfRead == NULL ) return FALSE;
	pAisa59DataFullRead = GetProcAddress( hDLL, _T("Aisa59DataFullRead"));
	if ( pAisa59DataFullRead == NULL ) return FALSE;
	pAisa59CommandWrite = GetProcAddress( hDLL, _T("Aisa59CommandWrite"));
	if ( pAisa59CommandWrite == NULL ) return FALSE;
	pAisa59DataHalfWrite = GetProcAddress( hDLL, _T("Aisa59DataHalfWrite"));
	if ( pAisa59DataHalfWrite == NULL ) return FALSE;
	pAisa59DataFullWrite = GetProcAddress( hDLL, _T("Aisa59DataFullWrite"));
	if ( pAisa59DataFullWrite == NULL ) return FALSE;

	return TRUE;	// SẴAhX擾
}





